import { getJstj, getTzwcqkTableData } from "../data/table/newConstruct/ycrh";

export async function getTzwcqk(req, res) {
    let line = req.query.line || "全部";
    let year = req.query.year || 2023;
    let tableData = getTzwcqkTableData();

    let dataMap = {};
    tableData["投资完成情况"].bodyList.forEach(sbuList => {
        let name = sbuList[0];

        let yearCount = sbuList[2];//年度完成
        let yearCountRelocation = sbuList[4];//年度完成动迁
        let yearExpected = sbuList[1];//计划投资额
        let yearExpectedRelocation = sbuList[3];//年度计划动迁
        let yearProportion = yearExpected == 0 ? 0 : Math.ceil((yearCount / yearExpected)*100)/100;

        let overCount = sbuList[6];//累计完成
        let overCountRelocation = sbuList[8];//年度完成动迁
        let overExpected = sbuList[5];//计划投资额
        let overExpectedRelocation = sbuList[7];//年度计划动迁
        let overProportion = overExpected == 0 ? 0 : Math.ceil((overCount / overExpected)*100 )/100;

        dataMap[name] = {
            "year":{
                count:yearCount,
                countRelocation:yearCountRelocation,
                expected:yearExpected,
                expectedRelocation:yearExpectedRelocation,
                proportion:yearProportion
            },
            "overall":{
                count:overCount,
                countRelocation:overCountRelocation,
                expected:overExpected,
                expectedRelocation:overExpectedRelocation,
                proportion:overProportion
            }
        }

    });

    let result:any = {};
    
    if (line == "全部") {
        let data:any = {"year":{}, "overall":{} }
        for (let key in dataMap) {
            let {year, overall} = dataMap[key];
            for (let subKey in year) {
                if (!data["year"][subKey]) data["year"][subKey] = 0;
                data["year"][subKey] += year[subKey];
            } 
            for (let subKey in overall) {
                if (!data["overall"][subKey]) data["overall"][subKey] = 0;
                data["overall"][subKey] += overall[subKey];
            } 
        }
        result["annualAccumulation"] = {
            "completionAmount": 0,//年度完成额
            "proportion": data["year"].proportion == 0 ? 0 : Math.ceil((data["year"].count / data["year"].expected)* 100 )/100,
            "count": Math.ceil(data["year"].count/100),//年度累计投资额
            "countRelocation":Math.ceil( data["year"].countRelocation/100),//年度累计动迁
            "expected":Math.ceil( data["year"].expected/100),//计划投资额
            "expectedRelocation":Math.ceil( data["year"].expectedRelocation/100),//年度计划动迁
        };
        result["overall"] = {
            "completionAmount":0,//累计完成额
            "proportion": data["overall"].expected == 0 ? 0 : Math.ceil((data["overall"].count / data["overall"].expected)*100 )/ 100,
            "count": Math.ceil(data["overall"].count/100),//年度累计投资额
            "countRelocation": Math.ceil(data["overall"].countRelocation/100),//年度累计动迁
            "expected": Math.ceil(data["overall"].expected/100),//计划投资额
            "expectedRelocation": Math.ceil(data["overall"].expectedRelocation/100),//年度计划动迁
        };
        console.log();
       
    } else {
        let defalut = {
            year:{
                count:0, countRelocation:0, expected:0, expectedRelocation:0, proportion:0,
            },
            overall:{
                count:0, countRelocation:0, expected:0, expectedRelocation:0, proportion:0,
            }
        }
        let data = dataMap[line] || defalut;
        result["annualAccumulation"] = {
            "completionAmount": 0,//年度完成额
            "proportion": data["year"].proportion,//完成比
            "count":Math.ceil( data["year"].count/100),//年度累计投资额
            "countRelocation":Math.ceil( data["year"].countRelocation/100),//年度累计动迁
            "expected":Math.ceil( data["year"].expected/100),//计划投资额
            "expectedRelocation":Math.ceil( data["year"].expectedRelocation/100),//年度计划动迁
        };
        result["overall"] = {
            "completionAmount":0,//累计完成额
            "proportion": data["overall"].proportion,//完成比
            "count": Math.ceil(data["overall"].count/100),//年度累计投资额
            "countRelocation": Math.ceil(data["overall"].countRelocation/100),//年度累计动迁
            "expected": Math.ceil(data["overall"].expected/100),//计划投资额
            "expectedRelocation": Math.ceil(data["overall"].expectedRelocation/100),//年度计划动迁
        };
        
    }

    res.send(result);
}


export async function getHtjeyjzl(req, res) {
    let line = req.query.line || "全部";

    let excelData = getJstj();

    let result:any = {};

    result["base"] = {
        "accumulatedContractAmountSigned":0,//累计签合同金额
        "estimatedTotalValue":0,//概算总值
        "totalTargetCost":0,//目标成本总值
    };
    let titleList = ["车站", "区间", "轨道", "通讯", "信号", "供电", "综合监控"];
    result["detailedList"] = [];
    if (line == "全部") {
        let map = {};
        for (let key in excelData) {
            let dataList = excelData[key].bodyList[excelData[key].bodyList.length -1];
            result["base"].accumulatedContractAmountSigned = dataList[1];
            result["base"].estimatedTotalValue = dataList[2];
            result["base"].totalTargetCost = dataList[3];

           
            excelData[key].bodyList.forEach(subList => {
                let title = subList[0];
                if (title == "总数") return;
                if (!map[title]) map[title] = {ht:0, gs:0, cb:0};
                
                map[title].ht += subList[1];
                map[title].gs += subList[2];
                map[title].cb += subList[3];
            });
        }
        titleList.forEach(str => {
            let item = map[str];
            result["detailedList"].push({
                type:str,
                estimated:item.gs,//概算
                targetCost:item.cb,//目标成本
                accumulatedContractAmountSigned:item.ht,//累计签合同金额
            });
        });
    } else {
        let checkList = excelData[line]? excelData[line].bodyList : [0,0,0,0];
        let allList = checkList[checkList.length-1];
        result["base"].accumulatedContractAmountSigned = allList[1];
        result["base"].estimatedTotalValue = allList[2];
        result["base"].totalTargetCost = allList[3];
        let map = {};
        checkList.forEach(subList => {
            let title = subList[0];
            if (title == "总数") return;
            if (!map[title]) map[title] = {ht:0, gs:0, cb:0};
            
            map[title].ht = subList[1];
            map[title].gs = subList[2];
            map[title].cb = subList[3];
        });
        titleList.forEach(str => {
            let item = map[str];
            result["detailedList"].push({
                type:str,
                estimated:item.gs,//概算
                targetCost:item.cb,//目标成本
                accumulatedContractAmountSigned:item.ht,//累计签合同金额
            });
        });
    }

    result["title"] = ["累计签合同值(含变更)", "概算值", "目标成本"]

    res.send(result);
}

export async function getDetailedData(req, res) {
    let line = req.query.line || "";

    let result:any = {};

    result["data"] = {
        "车站":[
            {
                name:"高架区间",//费用名称
                accumulatedSignedContractValue:15.11,//累计签约合同值
                estimated:200,//概算值
                budgetDifference:122,//概算差额
                targetCost:1000,//目标成本
    
            },
            {
                name:"通道区间",//费用名称
                accumulatedSignedContractValue:15.11,//累计签约合同值
                estimated:200,//概算值
                budgetDifference:122,//概算差额
                targetCost:1000,//目标成本
    
            },
            {
                name:"出入场线",//费用名称
                accumulatedSignedContractValue:15.11,//累计签约合同值
                estimated:200,//概算值
                budgetDifference:122,//概算差额
                targetCost:1000,//目标成本
    
            }
        ],
        "区间":[
            {
                name:"高架区间",//费用名称
                accumulatedSignedContractValue:15.11,//累计签约合同值
                estimated:200,//概算值
                budgetDifference:122,//概算差额
                targetCost:1000,//目标成本
    
            },
            {
                name:"高架区间",//费用名称
                accumulatedSignedContractValue:15.11,//累计签约合同值
                estimated:200,//概算值
                budgetDifference:122,//概算差额
                targetCost:1000,//目标成本
    
            },
            {
                name:"高架区间",//费用名称
                accumulatedSignedContractValue:15.11,//累计签约合同值
                estimated:200,//概算值
                budgetDifference:122,//概算差额
                targetCost:1000,//目标成本
    
            }
        ]
    }
   

    res.send(result);
}
